require_relative 'lib/svent'

Svent.run do |em|

  em.on(:exit) do |_, info|
    puts 'bye!'
    info[:exit] = true
    Svent.stop
  end

  em.on(:hello) do
    puts 'world!'
  end

  em.on(:input) do |_, info|
    input = info.input.chop
    p "help!#{info.input}"
    em.trigger(:exit, info) if input == 'exit'
    em.trigger(:hello, info) if input == 'hello'
  end

  em.on(:run) do |helper, info|
    helper.loop(lambda{ info.exit }) do
      print info.code
      info[:input] = gets
      em.trigger(:input, info)
    end
  end
  em.trigger(:run, {code: 'StartScene>', exit: false})
end